<?php
/**
 * ThemesApi
 * PHP version 7.3
 *
 * @category Class
 * @package  Ensi\CommunicationManagerClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Communication manager
 *
 * Ensi Communication manager
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CommunicationManagerClient\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Ensi\CommunicationManagerClient\ApiException;
use Ensi\CommunicationManagerClient\Configuration;
use Ensi\CommunicationManagerClient\HeaderSelector;
use Ensi\CommunicationManagerClient\ObjectSerializer;

/**
 * ThemesApi Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CommunicationManagerClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ThemesApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $host_index (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        int $host_index = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $host_index;
    }

    /**
     * Set the host index
     */
    public function setHostIndex(int $host_index): void
    {
        $this->hostIndex = $host_index;
    }

    /**
     * Get the host index
     */
    public function getHostIndex(): int
    {
        return $this->hostIndex;
    }

    public function getConfig(): Configuration
    {
        return $this->config;
    }

    /**
     * Operation createTheme
     *
     * Создание объекта типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\CreateThemeRequest $create_theme_request create_theme_request (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CommunicationManagerClient\Dto\ThemeResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse
     */
    public function createTheme($create_theme_request)
    {
        list($response) = $this->createThemeWithHttpInfo($create_theme_request);
        return $response;
    }

    /**
     * Operation createThemeWithHttpInfo
     *
     * Создание объекта типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\CreateThemeRequest $create_theme_request (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CommunicationManagerClient\Dto\ThemeResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function createThemeWithHttpInfo($create_theme_request)
    {
        $request = $this->createThemeRequest($create_theme_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 201:
                    if ('\Ensi\CommunicationManagerClient\Dto\ThemeResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ThemeResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CommunicationManagerClient\Dto\ThemeResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ThemeResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation createThemeAsync
     *
     * Создание объекта типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\CreateThemeRequest $create_theme_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createThemeAsync($create_theme_request)
    {
        return $this->createThemeAsyncWithHttpInfo($create_theme_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createThemeAsyncWithHttpInfo
     *
     * Создание объекта типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\CreateThemeRequest $create_theme_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createThemeAsyncWithHttpInfo($create_theme_request)
    {
        $returnType = '\Ensi\CommunicationManagerClient\Dto\ThemeResponse';
        $request = $this->createThemeRequest($create_theme_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createTheme'
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\CreateThemeRequest $create_theme_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createThemeRequest($create_theme_request)
    {
        // verify the required parameter 'create_theme_request' is set
        if ($create_theme_request === null || (is_array($create_theme_request) && count($create_theme_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $create_theme_request when calling createTheme'
            );
        }

        $resourcePath = '/themes';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        $clientOriginalFilenamesHolder = [];
        // body params
        $_tempBody = null;
        if (isset($create_theme_request)) {
            $_tempBody = $create_theme_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $temp = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];

                    if (isset($clientOriginalFilenamesHolder[$formParamName])) {
                        $temp['filename'] = $clientOriginalFilenamesHolder[$formParamName];
                    }

                    $multipartContents[] = $temp;
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deleteTheme
     *
     * Удаление объекта типа Theme
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CommunicationManagerClient\Dto\EmptyDataResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse
     */
    public function deleteTheme($id)
    {
        list($response) = $this->deleteThemeWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation deleteThemeWithHttpInfo
     *
     * Удаление объекта типа Theme
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CommunicationManagerClient\Dto\EmptyDataResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteThemeWithHttpInfo($id)
    {
        $request = $this->deleteThemeRequest($id);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CommunicationManagerClient\Dto\EmptyDataResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\EmptyDataResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CommunicationManagerClient\Dto\EmptyDataResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\EmptyDataResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deleteThemeAsync
     *
     * Удаление объекта типа Theme
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteThemeAsync($id)
    {
        return $this->deleteThemeAsyncWithHttpInfo($id)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteThemeAsyncWithHttpInfo
     *
     * Удаление объекта типа Theme
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteThemeAsyncWithHttpInfo($id)
    {
        $returnType = '\Ensi\CommunicationManagerClient\Dto\EmptyDataResponse';
        $request = $this->deleteThemeRequest($id);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteTheme'
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteThemeRequest($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling deleteTheme'
            );
        }
        if ($id < 1) {
            throw new \InvalidArgumentException('invalid value for "$id" when calling ThemesApi.deleteTheme, must be bigger than or equal to 1.');
        }


        $resourcePath = '/themes/{id}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                '{' . 'id' . '}',
                ObjectSerializer::toPathValue($id),
                $resourcePath
            );
        }
        $clientOriginalFilenamesHolder = [];
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $temp = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];

                    if (isset($clientOriginalFilenamesHolder[$formParamName])) {
                        $temp['filename'] = $clientOriginalFilenamesHolder[$formParamName];
                    }

                    $multipartContents[] = $temp;
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation patchTheme
     *
     * Изменение объекта типа типа Theme
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CommunicationManagerClient\Dto\PatchThemeRequest $patch_theme_request patch_theme_request (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CommunicationManagerClient\Dto\ThemeResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse
     */
    public function patchTheme($id, $patch_theme_request)
    {
        list($response) = $this->patchThemeWithHttpInfo($id, $patch_theme_request);
        return $response;
    }

    /**
     * Operation patchThemeWithHttpInfo
     *
     * Изменение объекта типа типа Theme
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CommunicationManagerClient\Dto\PatchThemeRequest $patch_theme_request (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CommunicationManagerClient\Dto\ThemeResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchThemeWithHttpInfo($id, $patch_theme_request)
    {
        $request = $this->patchThemeRequest($id, $patch_theme_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CommunicationManagerClient\Dto\ThemeResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ThemeResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CommunicationManagerClient\Dto\ThemeResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ThemeResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation patchThemeAsync
     *
     * Изменение объекта типа типа Theme
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CommunicationManagerClient\Dto\PatchThemeRequest $patch_theme_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function patchThemeAsync($id, $patch_theme_request)
    {
        return $this->patchThemeAsyncWithHttpInfo($id, $patch_theme_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation patchThemeAsyncWithHttpInfo
     *
     * Изменение объекта типа типа Theme
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CommunicationManagerClient\Dto\PatchThemeRequest $patch_theme_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function patchThemeAsyncWithHttpInfo($id, $patch_theme_request)
    {
        $returnType = '\Ensi\CommunicationManagerClient\Dto\ThemeResponse';
        $request = $this->patchThemeRequest($id, $patch_theme_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'patchTheme'
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CommunicationManagerClient\Dto\PatchThemeRequest $patch_theme_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function patchThemeRequest($id, $patch_theme_request)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling patchTheme'
            );
        }
        if ($id < 1) {
            throw new \InvalidArgumentException('invalid value for "$id" when calling ThemesApi.patchTheme, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'patch_theme_request' is set
        if ($patch_theme_request === null || (is_array($patch_theme_request) && count($patch_theme_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $patch_theme_request when calling patchTheme'
            );
        }

        $resourcePath = '/themes/{id}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                '{' . 'id' . '}',
                ObjectSerializer::toPathValue($id),
                $resourcePath
            );
        }
        $clientOriginalFilenamesHolder = [];
        // body params
        $_tempBody = null;
        if (isset($patch_theme_request)) {
            $_tempBody = $patch_theme_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $temp = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];

                    if (isset($clientOriginalFilenamesHolder[$formParamName])) {
                        $temp['filename'] = $clientOriginalFilenamesHolder[$formParamName];
                    }

                    $multipartContents[] = $temp;
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'PATCH',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation searchThemes
     *
     * Поиск объектов типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\SearchThemesRequest $search_themes_request search_themes_request (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CommunicationManagerClient\Dto\SearchThemesResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse
     */
    public function searchThemes($search_themes_request)
    {
        list($response) = $this->searchThemesWithHttpInfo($search_themes_request);
        return $response;
    }

    /**
     * Operation searchThemesWithHttpInfo
     *
     * Поиск объектов типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\SearchThemesRequest $search_themes_request (required)
     *
     * @throws \Ensi\CommunicationManagerClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CommunicationManagerClient\Dto\SearchThemesResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse|\Ensi\CommunicationManagerClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function searchThemesWithHttpInfo($search_themes_request)
    {
        $request = $this->searchThemesRequest($search_themes_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CommunicationManagerClient\Dto\SearchThemesResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\SearchThemesResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CommunicationManagerClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CommunicationManagerClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CommunicationManagerClient\Dto\SearchThemesResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\SearchThemesResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CommunicationManagerClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation searchThemesAsync
     *
     * Поиск объектов типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\SearchThemesRequest $search_themes_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchThemesAsync($search_themes_request)
    {
        return $this->searchThemesAsyncWithHttpInfo($search_themes_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation searchThemesAsyncWithHttpInfo
     *
     * Поиск объектов типа Theme
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\SearchThemesRequest $search_themes_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchThemesAsyncWithHttpInfo($search_themes_request)
    {
        $returnType = '\Ensi\CommunicationManagerClient\Dto\SearchThemesResponse';
        $request = $this->searchThemesRequest($search_themes_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'searchThemes'
     *
     * @param  \Ensi\CommunicationManagerClient\Dto\SearchThemesRequest $search_themes_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function searchThemesRequest($search_themes_request)
    {
        // verify the required parameter 'search_themes_request' is set
        if ($search_themes_request === null || (is_array($search_themes_request) && count($search_themes_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $search_themes_request when calling searchThemes'
            );
        }

        $resourcePath = '/themes:search';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        $clientOriginalFilenamesHolder = [];
        // body params
        $_tempBody = null;
        if (isset($search_themes_request)) {
            $_tempBody = $search_themes_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $temp = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];

                    if (isset($clientOriginalFilenamesHolder[$formParamName])) {
                        $temp['filename'] = $clientOriginalFilenamesHolder[$formParamName];
                    }

                    $multipartContents[] = $temp;
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption(): array
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
